CREATE TABLE IF NOT EXISTS `modules` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(50) NOT NULL,
  `script` longtext NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY (`name`)
)ENGINE=InnoDB;

CREATE TABLE IF NOT EXISTS `handlers` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(50) NOT NULL,
  `script` longtext NOT NULL,
  `context` longtext NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY (`name`)
)ENGINE=InnoDB;

CREATE TABLE IF NOT EXISTS `matches` (
  `n` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `oid` varchar(992) NOT NULL,
  `handler_id` int(11) unsigned,
  UNIQUE KEY (`n`),
  FOREIGN KEY (handler_id) REFERENCES handlers(id) ON DELETE CASCADE
)ENGINE=MyISAM;

CREATE OR REPLACE VIEW handlers_with_matchers (id, name, script, context, oid) AS
  SELECT h.id, h.name, h.script, h.context, GROUP_CONCAT(m.oid SEPARATOR '\n')
  FROM handlers AS h left join matches AS m ON h.id = m.handler_id GROUP BY h.id;

CREATE TABLE IF NOT EXISTS `subservices` (
  `host` varchar(75),
  `service` varchar(160),
  `tag` varchar(160),
  `state` tinyint(1) NOT NULL,
  `message` varchar(1000) NOT NULL,
  `count` int NOT NULL,
  `trapoid` varchar(992) NOT NULL,
  `trap` text,
  `time` datetime,
  CONSTRAINT host_service_tag UNIQUE (`host`, `service`, `tag`)
)ENGINE=InnoDB;

CREATE TABLE IF NOT EXISTS `meta` (
  `name` varchar(32) NOT NULL,
  `data` varchar(32) NOT NULL,
  PRIMARY KEY (`name`)
)ENGINE=InnoDB;

INSERT INTO `meta` VALUES ('processor_version', '1')
  ON DUPLICATE KEY UPDATE `data` = '1';

INSERT INTO `meta` VALUES ('last_update', '')
  ON DUPLICATE KEY UPDATE `data` = '';

CREATE TABLE IF NOT EXISTS `logs` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `time` timestamp,
  `handler` varchar(50),
  `message` text,
  PRIMARY KEY (`id`)
)ENGINE=InnoDB;
